<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<!--NewPage-->
<HTML>
<HEAD>
<!-- Generated by javadoc (build 1.5.0_17) on Fri Dec 04 18:31:07 CET 2009 -->
<TITLE>
AdjacencyFilter
</TITLE>

<META NAME="keywords" CONTENT="ch.javasoft.metabolic.efm.tree.AdjacencyFilter interface">

<LINK REL ="stylesheet" TYPE="text/css" HREF="../../../../../stylesheet.css" TITLE="Style">

<SCRIPT type="text/javascript">
function windowTitle()
{
    parent.document.title="AdjacencyFilter";
}
</SCRIPT>
<NOSCRIPT>
</NOSCRIPT>

</HEAD>

<BODY BGCOLOR="white" onload="windowTitle();">


<!-- ========= START OF TOP NAVBAR ======= -->
<A NAME="navbar_top"><!-- --></A>
<A HREF="#skip-navbar_top" title="Skip navigation links"></A>
<TABLE BORDER="0" WIDTH="100%" CELLPADDING="1" CELLSPACING="0" SUMMARY="">
<TR>
<TD COLSPAN=2 BGCOLOR="#EEEEFF" CLASS="NavBarCell1">
<A NAME="navbar_top_firstrow"><!-- --></A>
<TABLE BORDER="0" CELLPADDING="0" CELLSPACING="3" SUMMARY="">
  <TR ALIGN="center" VALIGN="top">
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../../overview-summary.html"><FONT CLASS="NavBarFont1"><B>Overview</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="package-summary.html"><FONT CLASS="NavBarFont1"><B>Package</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#FFFFFF" CLASS="NavBarCell1Rev"> &nbsp;<FONT CLASS="NavBarFont1Rev"><B>Class</B></FONT>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="class-use/AdjacencyFilter.html"><FONT CLASS="NavBarFont1"><B>Use</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="package-tree.html"><FONT CLASS="NavBarFont1"><B>Tree</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../../deprecated-list.html"><FONT CLASS="NavBarFont1"><B>Deprecated</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../../index-files/index-1.html"><FONT CLASS="NavBarFont1"><B>Index</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../../help-doc.html"><FONT CLASS="NavBarFont1"><B>Help</B></FONT></A>&nbsp;</TD>
  </TR>
</TABLE>
</TD>
<TD ALIGN="right" VALIGN="top" ROWSPAN=3><EM>
</EM>
</TD>
</TR>

<TR>
<TD BGCOLOR="white" CLASS="NavBarCell2"><FONT SIZE="-2">
&nbsp;PREV CLASS&nbsp;
&nbsp;<A HREF="../../../../../ch/javasoft/metabolic/efm/tree/AdjacencyPrecondition.html" title="interface in ch.javasoft.metabolic.efm.tree"><B>NEXT CLASS</B></A></FONT></TD>
<TD BGCOLOR="white" CLASS="NavBarCell2"><FONT SIZE="-2">
  <A HREF="../../../../../index.html?ch/javasoft/metabolic/efm/tree/AdjacencyFilter.html" target="_top"><B>FRAMES</B></A>  &nbsp;
&nbsp;<A HREF="AdjacencyFilter.html" target="_top"><B>NO FRAMES</B></A>  &nbsp;
&nbsp;<SCRIPT type="text/javascript">
  <!--
  if(window==top) {
    document.writeln('<A HREF="../../../../../allclasses-noframe.html"><B>All Classes</B></A>');
  }
  //-->
</SCRIPT>
<NOSCRIPT>
  <A HREF="../../../../../allclasses-noframe.html"><B>All Classes</B></A>
</NOSCRIPT>


</FONT></TD>
</TR>
<TR>
<TD VALIGN="top" CLASS="NavBarCell3"><FONT SIZE="-2">
  SUMMARY:&nbsp;NESTED&nbsp;|&nbsp;FIELD&nbsp;|&nbsp;CONSTR&nbsp;|&nbsp;<A HREF="#method_summary">METHOD</A></FONT></TD>
<TD VALIGN="top" CLASS="NavBarCell3"><FONT SIZE="-2">
DETAIL:&nbsp;FIELD&nbsp;|&nbsp;CONSTR&nbsp;|&nbsp;<A HREF="#method_detail">METHOD</A></FONT></TD>
</TR>
</TABLE>
<A NAME="skip-navbar_top"></A>
<!-- ========= END OF TOP NAVBAR ========= -->

<HR>
<!-- ======== START OF CLASS DATA ======== -->
<H2>
<FONT SIZE="-1">
ch.javasoft.metabolic.efm.tree</FONT>
<BR>
Interface AdjacencyFilter&lt;T extends <A HREF="../../../../../ch/javasoft/metabolic/efm/concurrent/ConcurrentToken.html" title="interface in ch.javasoft.metabolic.efm.concurrent">ConcurrentToken</A>&gt;</H2>
<DL>
<DT><B>All Known Implementing Classes:</B> <DD><A HREF="../../../../../ch/javasoft/metabolic/efm/tree/rankup/DefaultRankUpAdjacencyFilter.html" title="class in ch.javasoft.metabolic.efm.tree.rankup">DefaultRankUpAdjacencyFilter</A>, <A HREF="../../../../../ch/javasoft/metabolic/efm/tree/search/DefaultSearchAdjacencyFilter.html" title="class in ch.javasoft.metabolic.efm.tree.search">DefaultSearchAdjacencyFilter</A></DD>
</DL>
<HR>
<DL>
<DT><PRE>public interface <A HREF="../../../../../src-html/ch/javasoft/metabolic/efm/tree/AdjacencyFilter.html#line.52"><B>AdjacencyFilter&lt;T extends <A HREF="../../../../../ch/javasoft/metabolic/efm/concurrent/ConcurrentToken.html" title="interface in ch.javasoft.metabolic.efm.concurrent">ConcurrentToken</A>&gt;</B></A></DL>
</PRE>

<P>
The <code>AdjacencyFilter</code> is the actual interface to implement for
 the adjacency testing of modes. It is a filter and not a test since multiple
 (possibly similar) candidates are tested in one go, that is, non-adjacent
 pairs are <i>filtered out</i>. Some implementations might profit from the
 bulk procession and eliminate multiple candidates with a single test.
<P>

<P>
<HR>

<P>

<!-- ========== METHOD SUMMARY =========== -->

<A NAME="method_summary"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
<TH ALIGN="left" COLSPAN="2"><FONT SIZE="+2">
<B>Method Summary</B></FONT></TH>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>
<TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0" SUMMARY="">
<TR ALIGN="right" VALIGN="">
<TD NOWRAP><FONT SIZE="-1">
<CODE>&lt;Col extends <A HREF="../../../../../ch/javasoft/metabolic/efm/column/Column.html" title="interface in ch.javasoft.metabolic.efm.column">Column</A>,N extends <A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/Number.html" title="class or interface in java.lang">Number</A>&gt; 
<BR>
boolean</CODE></FONT></TD>
</TR>
</TABLE>
</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../ch/javasoft/metabolic/efm/tree/AdjacencyFilter.html#filter(ch.javasoft.metabolic.efm.column.ColumnHome, ch.javasoft.metabolic.efm.model.AdjEnumModel, T, ch.javasoft.metabolic.efm.column.AdjCandidates, ch.javasoft.bitset.IBitSet)">filter</A></B>(<A HREF="../../../../../ch/javasoft/metabolic/efm/column/ColumnHome.html" title="interface in ch.javasoft.metabolic.efm.column">ColumnHome</A>&lt;N,Col&gt;&nbsp;columnHome,
             <A HREF="../../../../../ch/javasoft/metabolic/efm/model/AdjEnumModel.html" title="class in ch.javasoft.metabolic.efm.model">AdjEnumModel</A>&lt;Col&gt;&nbsp;iterationModel,
             <A HREF="../../../../../ch/javasoft/metabolic/efm/tree/AdjacencyFilter.html" title="type parameter in AdjacencyFilter">T</A>&nbsp;token,
             <A HREF="../../../../../ch/javasoft/metabolic/efm/column/AdjCandidates.html" title="class in ch.javasoft.metabolic.efm.column">AdjCandidates</A>&lt;Col&gt;&nbsp;candidates,
             <A HREF="../../../../../ch/javasoft/bitset/IBitSet.html" title="interface in ch.javasoft.bitset">IBitSet</A>&nbsp;commonPattern)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Filters the given candidate pairs and returns true if any candidate is 
 left.</TD>
</TR>
</TABLE>
&nbsp;
<P>

<!-- ============ METHOD DETAIL ========== -->

<A NAME="method_detail"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
<TH ALIGN="left" COLSPAN="1"><FONT SIZE="+2">
<B>Method Detail</B></FONT></TH>
</TR>
</TABLE>

<A NAME="filter(ch.javasoft.metabolic.efm.column.ColumnHome,ch.javasoft.metabolic.efm.model.AdjEnumModel,ch.javasoft.metabolic.efm.concurrent.ConcurrentToken,ch.javasoft.metabolic.efm.column.AdjCandidates,ch.javasoft.bitset.IBitSet)"><!-- --></A><A NAME="filter(ch.javasoft.metabolic.efm.column.ColumnHome, ch.javasoft.metabolic.efm.model.AdjEnumModel, T, ch.javasoft.metabolic.efm.column.AdjCandidates, ch.javasoft.bitset.IBitSet)"><!-- --></A><H3>
filter</H3>
<PRE>
&lt;Col extends <A HREF="../../../../../ch/javasoft/metabolic/efm/column/Column.html" title="interface in ch.javasoft.metabolic.efm.column">Column</A>,N extends <A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/Number.html" title="class or interface in java.lang">Number</A>&gt; boolean <A HREF="../../../../../src-html/ch/javasoft/metabolic/efm/tree/AdjacencyFilter.html#line.70"><B>filter</B></A>(<A HREF="../../../../../ch/javasoft/metabolic/efm/column/ColumnHome.html" title="interface in ch.javasoft.metabolic.efm.column">ColumnHome</A>&lt;N,Col&gt;&nbsp;columnHome,
                                                     <A HREF="../../../../../ch/javasoft/metabolic/efm/model/AdjEnumModel.html" title="class in ch.javasoft.metabolic.efm.model">AdjEnumModel</A>&lt;Col&gt;&nbsp;iterationModel,
                                                     <A HREF="../../../../../ch/javasoft/metabolic/efm/tree/AdjacencyFilter.html" title="type parameter in AdjacencyFilter">T</A>&nbsp;token,
                                                     <A HREF="../../../../../ch/javasoft/metabolic/efm/column/AdjCandidates.html" title="class in ch.javasoft.metabolic.efm.column">AdjCandidates</A>&lt;Col&gt;&nbsp;candidates,
                                                     <A HREF="../../../../../ch/javasoft/bitset/IBitSet.html" title="interface in ch.javasoft.bitset">IBitSet</A>&nbsp;commonPattern)
               throws <A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/io/IOException.html" title="class or interface in java.io">IOException</A></PRE>
<DL>
<DD>Filters the given candidate pairs and returns true if any candidate is 
 left. The common pattern (the intersection of all intersect patterns of 
 all candidates) can be used for more efficient filtering.
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>columnHome</CODE> - the columh home, defines column and data type<DD><CODE>iterationModel</CODE> - access to columns and iteration step information<DD><CODE>token</CODE> - the tree traverser token<DD><CODE>candidates</CODE> - the adjacent mode pairs, the candidates to test<DD><CODE>commonPattern</CODE> - the intersection of all test zero sets, allowing
                                                        for early abortion if the combinatorial test is
                                                        used, and the union pattern of a tree node is
                                                        not a superset of this set
<DT><B>Returns:</B><DD>true if at least one candidate pair is left and thus adjacent
<DT><B>Throws:</B>
<DD><CODE><A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/io/IOException.html" title="class or interface in java.io">IOException</A></CODE></DL>
</DD>
</DL>
<!-- ========= END OF CLASS DATA ========= -->
<HR>


<!-- ======= START OF BOTTOM NAVBAR ====== -->
<A NAME="navbar_bottom"><!-- --></A>
<A HREF="#skip-navbar_bottom" title="Skip navigation links"></A>
<TABLE BORDER="0" WIDTH="100%" CELLPADDING="1" CELLSPACING="0" SUMMARY="">
<TR>
<TD COLSPAN=2 BGCOLOR="#EEEEFF" CLASS="NavBarCell1">
<A NAME="navbar_bottom_firstrow"><!-- --></A>
<TABLE BORDER="0" CELLPADDING="0" CELLSPACING="3" SUMMARY="">
  <TR ALIGN="center" VALIGN="top">
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../../overview-summary.html"><FONT CLASS="NavBarFont1"><B>Overview</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="package-summary.html"><FONT CLASS="NavBarFont1"><B>Package</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#FFFFFF" CLASS="NavBarCell1Rev"> &nbsp;<FONT CLASS="NavBarFont1Rev"><B>Class</B></FONT>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="class-use/AdjacencyFilter.html"><FONT CLASS="NavBarFont1"><B>Use</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="package-tree.html"><FONT CLASS="NavBarFont1"><B>Tree</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../../deprecated-list.html"><FONT CLASS="NavBarFont1"><B>Deprecated</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../../index-files/index-1.html"><FONT CLASS="NavBarFont1"><B>Index</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../../help-doc.html"><FONT CLASS="NavBarFont1"><B>Help</B></FONT></A>&nbsp;</TD>
  </TR>
</TABLE>
</TD>
<TD ALIGN="right" VALIGN="top" ROWSPAN=3><EM>
</EM>
</TD>
</TR>

<TR>
<TD BGCOLOR="white" CLASS="NavBarCell2"><FONT SIZE="-2">
&nbsp;PREV CLASS&nbsp;
&nbsp;<A HREF="../../../../../ch/javasoft/metabolic/efm/tree/AdjacencyPrecondition.html" title="interface in ch.javasoft.metabolic.efm.tree"><B>NEXT CLASS</B></A></FONT></TD>
<TD BGCOLOR="white" CLASS="NavBarCell2"><FONT SIZE="-2">
  <A HREF="../../../../../index.html?ch/javasoft/metabolic/efm/tree/AdjacencyFilter.html" target="_top"><B>FRAMES</B></A>  &nbsp;
&nbsp;<A HREF="AdjacencyFilter.html" target="_top"><B>NO FRAMES</B></A>  &nbsp;
&nbsp;<SCRIPT type="text/javascript">
  <!--
  if(window==top) {
    document.writeln('<A HREF="../../../../../allclasses-noframe.html"><B>All Classes</B></A>');
  }
  //-->
</SCRIPT>
<NOSCRIPT>
  <A HREF="../../../../../allclasses-noframe.html"><B>All Classes</B></A>
</NOSCRIPT>


</FONT></TD>
</TR>
<TR>
<TD VALIGN="top" CLASS="NavBarCell3"><FONT SIZE="-2">
  SUMMARY:&nbsp;NESTED&nbsp;|&nbsp;FIELD&nbsp;|&nbsp;CONSTR&nbsp;|&nbsp;<A HREF="#method_summary">METHOD</A></FONT></TD>
<TD VALIGN="top" CLASS="NavBarCell3"><FONT SIZE="-2">
DETAIL:&nbsp;FIELD&nbsp;|&nbsp;CONSTR&nbsp;|&nbsp;<A HREF="#method_detail">METHOD</A></FONT></TD>
</TR>
</TABLE>
<A NAME="skip-navbar_bottom"></A>
<!-- ======== END OF BOTTOM NAVBAR ======= -->

<HR>

</BODY>
</HTML>
